foreach name [array names env STOOOP*] {unset env($name)}                                ;# reset any existing environment variables
set env(STOOOPCHECKPROCEDURES) {}
source stooop.tcl
namespace import stooop::*

### check that member procedure invocation within constructor dos not break procedure checking debug mode

class a {}
proc a::a {this} {
    p $this
    q
}
proc a::~a {this} {}
proc a::p {this} {}
proc a::q {} {}
new a

class A {
    proc A {this} {
        p $this
        q
    }
    proc ~A {this} {}
    proc p {this} {}
    proc q {} {}
}
new A

class b {}
class b::c {}
proc b::c::c {this} {
    p $this
    q
}
proc b::c::~c {this} {}
proc b::c::p {this} {}
proc b::c::q {} {}
new b::c

class B {
    class C {
        proc C {this} {
            p $this
            q
        }
        proc ~C {this} {}
        proc p {this} {}
        proc q {} {}
    }
}
new B::C

